package Cases;

import java.io.*;
import java.io.File;

import neustore.base.DBIndex;//because we create a object of index.java
import neustore.base.LRUBuffer;//because we create an object of it




public class Test_Content_Full {

	
	public static void main(String[] args)throws IOException {
		
		//all the pages will be stored under this file name
		String filename3="TESTFILE3";
		File file= new File(filename3);
		if(file.delete())
		{
			 System.out.println("The old file with that name has been deleted");
			 
		}
		else
		{
			System.out.println("The file was not found");
		}
		
		//'buf' is an object of XMLBuffer class. Passews 2 arguments  5=Buffer size and 120=page size in bytes
		XMLBuffer buf3= new XMLBuffer(5,120);
		
		//Creating an object of XMLContent class and passing the 'buf3'(buffer) , filename and boolean value 'true' (indicating a new file has to be created with the passed filename)
		//If we do not plan to create a new file for Structure index, then the Constructor of the XMLContent class should send 'false' to its super class
		
		
		//creating an object of XMLContent class to test its methods
		XMLContent XC=new XMLContent(buf3,filename3,1);
		
		
		//This code would append the content
		String s=new String("This is just a test file and the length of this statement should be atleast 120 characters.");//this is 91 in length and does not cause overflow
		DiskAddress addr=XC.appendContent(s);
		
		//System.out.println("length:"+s.length());
		//appending this string will cause the overflow
		s=new String("This statemtn would certainly cause the content page to overflow");//this statement lenght is 64, that means the total length is 91+64=155
		System.out.println("length:"+s.length());
		
		DiskAddress da=new DiskAddress(10,1); ///assuming the content page id=10 and we are extracting from record number 1 i.e from the 1st byte
		s=XC.getContent(da,155);//155 is the length to be extracted, so we are entracted the whole content
		
		System.out.println("The entire content is"+s);
		
		
		//lets delete some content, so that page merge can be done
		da=new DiskAddress(10,80);//we will start deleting from the 70th byte to 125th i.e length=55 , so after deletion our content is 155-55=100 length and it can be in a single page(if page header is not greater than 20)
		int x=XC.deleteContent(da,55);
		
		System.out.println("Total characters now are:"+XC.getSize());
		
		
	}//end of Main() method
}//end of Test_Content_Full class
